Bug 1263653 - dht: Avoid double unlock in dht_refresh_layout_cbk
dht: Avoid double unlock in dht_refresh_layout_cbk
Status: CLOSED ERRATA
Product: Red Hat Gluster Storage
Classification: Red Hat
Component: distribute (Show other bugs)
3.1
Unspecified Unspecified
high Severity high
: ---
: RHGS 3.1.1
Assigned To: Susant Kumar Palai
Amit Chaurasia
: ZStream
Depends On:
Blocks: 1251815
  Show dependency treegraph
 
Reported: 2015-09-16 07:12 EDT by Susant Kumar Palai
Modified: 2015-10-27 20:10 EDT (History)
4 users (show)

See Also:
Fixed In Version: glusterfs-3.7.1-16
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-10-05 03:27:12 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2015:1845 normal SHIPPED_LIVE Moderate: Red Hat Gluster Storage 3.1 update 2015-10-05 07:06:22 EDT

  None (edit)
Description Susant Kumar Palai 2015-09-16 07:12:27 EDT
Document URL: 

Section Number and Name: 

Describe the issue: 
Currently in case of failure in dht_refresh_layout_cbk we unlock the object twice. 

Suggestions for improvement: 

Additional information:
Comment 2 Susant Kumar Palai 2015-09-16 07:47:46 EDT
Here is the code-snippet from dht_refresh_layout_cbk

<snip>
        return 0;

err:
        local->refresh_layout_unlock (frame, this, -1);

        dht_selfheal_dir_finish (frame, this, -1);<----- Here an extra lock and unwind. This needs to be removed.
        return 0;
</snip>
Comment 5 Amit Chaurasia 2015-09-23 08:07:47 EDT
Given that it is unlocking twice, chances were there if the folder ends up with 2 diffrent layout.

To verify this, followed following steps:

1.  Create a dist-rep vol with quota and min-free ON and 90% resp.
2. Filled the volume mounted on NFS and fuse both such that min free limit is crossed for atleast one brick.
3. Performed mkdir operation using GNU parallel.
4. Once folders were created, ran the same GNU parallel command again.
5. Counted the files to check if there are unexpected or double entry of a file.

No issues found. Marking the bug verified.
Comment 7 errata-xmlrpc 2015-10-05 03:27:12 EDT
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2015-1845.html

Note You need to log in before you can comment on or make changes to this bug.